<html lang="fr.slang">
  <body>
    <!-- Implements a minimal console mechanism -->
    <div id='console'>
    <script type='text/javascript'>
      function consoleLog(text) {
        document.getElementById("console").innerHTML += "<pre>" + text + "</pre>";
      };
    consoleLog("Testing (it takes about 5 seconds) ...");
    </script>

    <!-- Loads all aideweb functionnalities -->
    <script type='text/javascript' src='./HttpQuery.js'></script>
    <script type='text/javascript' src='./PersistantData.js'></script>
    <script type='text/javascript' src='./ServerEvent.js'></script>
    <script type='text/javascript' src='./RemanentForm.js'></script>
    <script type='text/javascript' src='./WrapperCC.js'></script>
    <script type='text/javascript' src='./cookies.js'></script>

    <!-- Implements the persistant mechanism testing -->
    <script type='text/javascript'>
    { 
      var persistantData = new PersistantData("http://localhost:8080/build/_test_tmp");
      // Testing the client/server mechanism getting a new ID
      let test_getNewID = false;
      {
        persistantData.getNewID(true, true, "suffix", function(value) { 
          consoleLog("Testing getNewID: " + value);
          test_getNewID = true;
        });
      }
      // Testing the persistent data load/list/save mechanism writing a minimal file
      let test_SaveLoad_list = true, test_SaveLoad_load = false;
      {
        persistantData.saveJSON("test", "OK", true, function() { 
          persistantData.list("json", function(filename) {
            if (filename != "test" && filename != "form-slug-my-index" /* because of test below */) {
              test_SaveLoad_list = false;
              consoleLog("Test error: Spurious file: '" + filename + "' in persistantData.list");
            }
          });
	    persistantData.loadJSON("test", "KO", function(value) {
	      if (value == "OK") {
              test_SaveLoad_load = true;
            } else {
	        consoleLog("Test error: Spurious value: '" + value + "' in persistantData.load");
            }
	    });
        });
      }
      // Reporting the test
      setTimeout(function() {
        if(!test_getNewID) consoleLog("Test error: getNewID failed");
        if(!test_SaveLoad_list) consoleLog("Test error: testSaveLoad_list failed");
        if(!test_SaveLoad_load) consoleLog("Test error: testSaveLoad_load failed");
        if(test_getNewID && test_SaveLoad_list && test_SaveLoad_load) consoleLog("Persistant data test passed, great !");
      }, 1000);
    }
    </script>

    <!-- Implements the RemanentForm mechanism testing -->
    <form id='form-slug' style='display:none'>
      <input name='form-index' type='text' value="my-index" required/>
      <input name='form-value' type='text' value="not-yet-defined" /> 
      <a id='form-load' href="#" onclick='remanentForm.load();'>Load the data</a>      
      <input id='form-save' type='submit' value='Save the data'/>
    </form>
    <script>
    {  
      let test_RemanentForm = true;
      let url = "http://localhost:8080/build/_test_tmp";
      var persistantData = new PersistantData(url);
      var remanentForm = new RemanentForm(url, "form-slug", "form-index", 
        // 3/ Saves the data and load the file to check it is ok
        function() {
          persistantData.loadJSON("form-slug-my-index", "", function(value) {
            test_RemanentForm &&= value["form-value"] == "my-next-value";
            consoleLog("Remanent form test " + (test_RemanentForm ? "passed, great !" : "failed"));
          });
        },
        // 2/ Reloads the data after 1/ change a value and resave
        function(value) {
          test_RemanentForm &&= value["form-value"] == "my-value";
          document.getElementsByName("form-value")[0].value = "my-next-value";
          document.getElementById("form-save").click();
        }
      );
      // 1/ Saves persistant data and ask form to reload
      persistantData.saveJSON("form-slug-my-index", 
        { "form-index" : "my-index", "form-value" : "my-value" }, true,
        function() {
          document.getElementById("form-load").click();
        }
      );
    }
    </script>

    <!-- Implements the WrapperCC mechanism testing -->
    <script>
    {
      var ccWrapper = new WrapperCC("http://localhost:8080/_test_cc_wrapper");
      ccWrapper.call("action=test", function(value) {
        let test_WrapperCC = value == "{ \"error\": \"wrong or unimplemented query\", \"query\": \"action=test\" }";
        consoleLog("WrapperCC test " + (test_WrapperCC ? "passed, great !" : "failed"));
      });
    }
    </script>

    <!-- Implements the event mechanism testing -->
    <script>
    {
      var serverEvent = new ServerEvent("http://localhost:8080/_test_event");
      serverEvent.clear();
      serverEvent.addClock(1000, 4);
      let test_ServerEvent = true, now = Date.now();
      serverEvent.onEvent(function(value) {
        if (1 < Math.abs(0.001 * (Date.now() - now) - (parseInt(value) + 1))) {
          consoleLog("Test error: spurious event service, idex: " + value);
          test_ServerEvent = false;
        }
        if (value == 3 && test_ServerEvent) {
          consoleLog("ServerEvent test passed, great ! (it was the last test)");
          // Stops the service
          setTimeout(function() {
            new HttpQuery("http://localhost:8080/stop").send();
          }, 4000);
        }
      }, 0, 4);
    }
    </script>

    <!-- Implements the Upload and testing -->

    <iframe scrolling='no' style='overflow:hidden;' src='../build/_test_upload/input.html' width='300px' height='40px'></iframe>

    <!-- Implements the cookies mechanism testing -->
    <script>
    {
      if (!document.URL.match(new RegExp("^file:/"))) {
        cookies.set("name", "value");
        if (cookies.get("name") != "value")
          consoleLog("Test error: cookies test failed: '" + cookies.get("name") + "'");
      }
    }
    </script>


    <!-- Implements the slugstring mechanism testing -->
    <script>
      if (document.documentElement.lang != "fr.slang")
      document.write("Upps unable to get the document lang attribute: " + document.documentElement.lang);
      lang = new URLSearchParams(window.location.search).get("lang");
      if (lang != undefined)
      document.write("Lang is defined in the URL as: " + lang);
    </script>
    <p data-slug="test">.</p>
    <script src="./slugstring.js"></script>
    <script>
      // Normally this is in an external file, but this is just a test
      strings_of_the_html_page = {
      "test": "If this strings is shown, the slugstring test is passed :)"
      };
      slugstring.fill(strings_of_the_html_page);
    </script>
 </body>
</html>
